=== modified file 'Makefile'
--- Makefile	2011-10-15 16:48:03 +0000
+++ Makefile	2011-10-22 00:46:35 +0000
@@ -260,12 +260,6 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	@echo "#################################################################"
-	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
-	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
-	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
-	@echo "# server as root if you didn't also unpack and compile it thus. #"
-	@echo "#################################################################"
 	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server

=== modified file 'TODO'
--- TODO	2011-11-13 13:55:45 +0000
+++ TODO	2011-11-09 17:16:03 +0000
@@ -7,7 +7,6 @@
 * mandos-applet
 
 * mandos-client
-** TODO [#A] Document network hook functionality
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use struct sockaddr_storage instead of a union
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
@@ -42,8 +41,7 @@
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
-** TODO Persistent state						  :BUGS:
-   /var/lib/mandos/*
+  
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
@@ -54,8 +52,6 @@
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Date+time on console log messages				  :BUGS:
-   Is this the default?
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on secrets given
@@ -69,7 +65,6 @@
    http://0pointer.de/blog/projects/systemd.html
    http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
-** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2011-11-13 20:49:21 +0000
+++ initramfs-tools-hook	2011-10-05 16:56:06 +0000
@@ -68,7 +68,6 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
-HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
@@ -107,24 +106,6 @@
     esac
 done
 
-# Copy network hooks
-for hook in /etc/mandos/network-hooks.d/*; do
-    case "`basename \"$hook\"`" in
-	"*") continue ;;
-	*[!A-Za-z0-9_-]*) continue ;;
-	*) test -d "$hook" || copy_exec "$hook" "${HOOKDIR}" ;;
-    esac
-    # Copy any files needed by the network hook
-    MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=files \
-	"$hook" files | while read file target; do
-	if [ -z "${target}" ]; then
-	    copy_exec "$file"
-	else
-	    copy_exec "$file" "$target"
-	fi
-    done
-done
-
 # GPGME needs /usr/bin/gpg
 if [ ! -e "${DESTDIR}/usr/bin/gpg" \
     -a -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* \

=== modified file 'mandos'
--- mandos	2011-10-15 16:48:03 +0000
+++ mandos	2011-11-09 17:16:03 +0000
@@ -63,6 +63,7 @@
 import cPickle as pickle
 import multiprocessing
 import types
+import hashlib
 
 import dbus
 import dbus.service
@@ -73,6 +74,7 @@
 import ctypes.util
 import xml.dom.minidom
 import inspect
+import Crypto.Cipher.AES
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -85,8 +87,9 @@
 
 version = "1.4.1"
 
-#logger = logging.getLogger('mandos')
-logger = logging.Logger('mandos')
+logger = logging.getLogger()
+stored_state_path = "/var/lib/mandos/clients.pickle"
+
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = str("/dev/log")))
@@ -96,11 +99,13 @@
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
-console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
+console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
+                                       ' [%(process)d]:'
                                        ' %(levelname)s:'
                                        ' %(message)s'))
 logger.addHandler(console)
 
+
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
@@ -164,10 +169,6 @@
                             .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
-                                % self.name))
         self.remove()
         try:
             self.add()
@@ -193,7 +194,7 @@
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
         self.entry_group_state_changed_match = (
             self.group.connect_to_signal(
-                'StateChanged', self .entry_group_state_changed))
+                'StateChanged', self.entry_group_state_changed))
         logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -265,6 +266,15 @@
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
+class AvahiServiceToSyslog(AvahiService):
+    def rename(self):
+        """Add the new name to the syslog messages"""
+        ret = AvahiService.rename(self)
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % self.name))
+        return ret
 
 def _timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
@@ -289,8 +299,9 @@
                      instance %(name)s can be used in the command.
     checker_initiator_tag: a gobject event source tag, or None
     created:    datetime.datetime(); (UTC) object creation
+    client_structure: Object describing what attributes a client has
+                      and is used for storing the client at exit
     current_checker_command: string; current running checker_command
-    disable_hook:  If set, called by disable() as disable_hook(self)
     disable_initiator_tag: a gobject event source tag, or None
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
@@ -299,6 +310,9 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
+    last_checker_status: integer between 0 and 255 reflecting exit status
+                         of last checker. -1 reflect crashed checker,
+                         or None.
     last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
@@ -331,7 +345,7 @@
     def approval_delay_milliseconds(self):
         return _timedelta_to_milliseconds(self.approval_delay)
     
-    def __init__(self, name = None, disable_hook=None, config=None):
+    def __init__(self, name = None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
@@ -357,23 +371,22 @@
                             % self.name)
         self.host = config.get("host", "")
         self.created = datetime.datetime.utcnow()
-        self.enabled = False
+        self.enabled = True
         self.last_approval_request = None
-        self.last_enabled = None
+        self.last_enabled = datetime.datetime.utcnow()
         self.last_checked_ok = None
+        self.last_checker_status = None
         self.timeout = string_to_delta(config["timeout"])
         self.extended_timeout = string_to_delta(config
                                                 ["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
-        self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
-        self.expires = None
+        self.expires = datetime.datetime.utcnow() + self.timeout
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
         self.current_checker_command = None
-        self.last_connect = None
         self._approved = None
         self.approved_by_default = config.get("approved_by_default",
                                               True)
@@ -385,11 +398,19 @@
         self.changedstate = (multiprocessing_manager
                              .Condition(multiprocessing_manager
                                         .Lock()))
+        self.client_structure = [attr for attr in self.__dict__.iterkeys() if not attr.startswith("_")]
+        self.client_structure.append("client_structure")
+
+
+        for name, t in inspect.getmembers(type(self),
+                                          lambda obj: isinstance(obj, property)):
+            if not name.startswith("_"):
+                self.client_structure.append(name)
     
+    # Send notice to process children that client state has changed
     def send_changedstate(self):
-        self.changedstate.acquire()
-        self.changedstate.notify_all()
-        self.changedstate.release()
+        with self.changedstate:
+            self.changedstate.notify_all()
     
     def enable(self):
         """Start this client's checker and timeout hooks"""
@@ -397,20 +418,10 @@
             # Already enabled
             return
         self.send_changedstate()
-        # Schedule a new checker to be started an 'interval' from now,
-        # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self.interval_milliseconds(),
-                                       self.start_checker))
-        # Schedule a disable() when 'timeout' has passed
         self.expires = datetime.datetime.utcnow() + self.timeout
-        self.disable_initiator_tag = (gobject.timeout_add
-                                   (self.timeout_milliseconds(),
-                                    self.disable))
         self.enabled = True
         self.last_enabled = datetime.datetime.utcnow()
-        # Also start a new checker *right now*.
-        self.start_checker()
+        self.init_checker()
     
     def disable(self, quiet=True):
         """Disable this client."""
@@ -428,23 +439,34 @@
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
-        if self.disable_hook:
-            self.disable_hook(self)
         self.enabled = False
         # Do not run this again if called by a gobject.timeout_add
         return False
     
     def __del__(self):
-        self.disable_hook = None
         self.disable()
-    
+
+    def init_checker(self):
+        # Schedule a new checker to be started an 'interval' from now,
+        # and every interval from then on.
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (self.interval_milliseconds(),
+                                       self.start_checker))
+        # Schedule a disable() when 'timeout' has passed
+        self.disable_initiator_tag = (gobject.timeout_add
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
+        # Also start a new checker *right now*.
+        self.start_checker()
+
+        
     def checker_callback(self, pid, condition, command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition):
-            exitstatus = os.WEXITSTATUS(condition)
-            if exitstatus == 0:
+            self.last_checker_status =  os.WEXITSTATUS(condition)
+            if self.last_checker_status == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
@@ -452,6 +474,7 @@
                 logger.info("Checker for %(name)s failed",
                             vars(self))
         else:
+            self.last_checker_status = -1
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
@@ -568,6 +591,52 @@
                 raise
         self.checker = None
 
+    # Encrypts a client secret and stores it in a varible encrypted_secret
+    def encrypt_secret(self, key):
+        # Encryption-key need to be of a specific size, so we hash inputed key
+        hasheng = hashlib.sha256()
+        hasheng.update(key)
+        encryptionkey = hasheng.digest()
+
+        # Create validation hash so we know at decryption if it was sucessful
+        hasheng = hashlib.sha256()
+        hasheng.update(self.secret)
+        validationhash = hasheng.digest()
+
+        # Encrypt secret
+        iv = os.urandom(Crypto.Cipher.AES.block_size)
+        ciphereng = Crypto.Cipher.AES.new(encryptionkey,
+                                        Crypto.Cipher.AES.MODE_CFB, iv)
+        ciphertext = ciphereng.encrypt(validationhash+self.secret)
+        self.encrypted_secret = (ciphertext, iv)
+
+    # Decrypt a encrypted client secret
+    def decrypt_secret(self, key):
+        # Decryption-key need to be of a specific size, so we hash inputed key
+        hasheng = hashlib.sha256()
+        hasheng.update(key)
+        encryptionkey = hasheng.digest()
+
+        # Decrypt encrypted secret
+        ciphertext, iv = self.encrypted_secret
+        ciphereng = Crypto.Cipher.AES.new(encryptionkey,
+                                        Crypto.Cipher.AES.MODE_CFB, iv)
+        plain = ciphereng.decrypt(ciphertext)
+
+        # Validate decrypted secret to know if it was succesful
+        hasheng = hashlib.sha256()
+        validationhash = plain[:hasheng.digest_size]
+        secret = plain[hasheng.digest_size:]
+        hasheng.update(secret)
+
+        # if validation fails, we use key as new secret. Otherwhise, we use
+        # the decrypted secret
+        if hasheng.digest() == validationhash:
+            self.secret = secret
+        else:
+            self.secret = key
+        del self.encrypted_secret
+
 
 def dbus_service_property(dbus_interface, signature="v",
                           access="readwrite", byte_arrays=False):
@@ -874,9 +943,10 @@
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
+        self.bus = bus
+        Client.__init__(self, *args, **kwargs)
+
         self._approvals_pending = 0
-        self.bus = bus
-        Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -1624,7 +1694,7 @@
         self.enabled = False
         self.clients = clients
         if self.clients is None:
-            self.clients = set()
+            self.clients = {}
         self.use_dbus = use_dbus
         self.gnutls_priority = gnutls_priority
         IPv6_TCPServer.__init__(self, server_address,
@@ -1677,7 +1747,7 @@
             fpr = request[1]
             address = request[2]
             
-            for c in self.clients:
+            for c in self.clients.itervalues():
                 if c.fingerprint == fpr:
                     client = c
                     break
@@ -1851,6 +1921,10 @@
                         " system bus interface")
     parser.add_argument("--no-ipv6", action="store_false",
                         dest="use_ipv6", help="Do not use IPv6")
+    parser.add_argument("--no-restore", action="store_false",
+                        dest="restore", help="Do not restore stored state",
+                        default=True)
+
     options = parser.parse_args()
     
     if options.check:
@@ -1891,7 +1965,7 @@
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel"):
+                   "use_dbus", "use_ipv6", "debuglevel", "restore"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -1970,14 +2044,13 @@
             raise error
     
     if not debug and not debuglevel:
-        syslogger.setLevel(logging.WARNING)
-        console.setLevel(logging.WARNING)
+        logger.setLevel(logging.WARNING)
     if debuglevel:
         level = getattr(logging, debuglevel.upper())
-        syslogger.setLevel(level)
-        console.setLevel(level)
+        logger.setLevel(level)
     
     if debug:
+        logger.setLevel(logging.DEBUG)
         # Enable all possible GnuTLS debugging
         
         # "Use a log level over 10 to enable all debugging options."
@@ -2024,9 +2097,10 @@
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiService(name = server_settings["servicename"],
-                           servicetype = "_mandos._tcp",
-                           protocol = protocol, bus = bus)
+    service = AvahiServiceToSyslog(name =
+                                   server_settings["servicename"],
+                                   servicetype = "_mandos._tcp",
+                                   protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings["interface"])))
@@ -2038,23 +2112,102 @@
     if use_dbus:
         client_class = functools.partial(ClientDBusTransitional,
                                          bus = bus)
-    def client_config_items(config, section):
-        special_settings = {
-            "approved_by_default":
-                lambda: config.getboolean(section,
-                                          "approved_by_default"),
-            }
-        for name, value in config.items(section):
+    
+    special_settings = {
+        # Some settings need to be accessd by special methods;
+        # booleans need .getboolean(), etc.  Here is a list of them:
+        "approved_by_default":
+            lambda section:
+            client_config.getboolean(section, "approved_by_default"),
+        }
+    # Construct a new dict of client settings of this form:
+    # { client_name: {setting_name: value, ...}, ...}
+    # with exceptions for any special settings as defined above
+    client_settings = dict((clientname,
+                           dict((setting,
+                                 (value if setting not in special_settings
+                                  else special_settings[setting](clientname)))
+                                for setting, value in client_config.items(clientname)))
+                          for clientname in client_config.sections())
+    
+    old_client_settings = {}
+    clients_data = []
+
+    # Get client data and settings from last running state. 
+    if server_settings["restore"]:
+        try:
+            with open(stored_state_path, "rb") as stored_state:
+                clients_data, old_client_settings = pickle.load(stored_state)
+            os.remove(stored_state_path)
+        except IOError as e:
+            logger.warning("Could not load persistant state: {0}".format(e))
+            if e.errno != errno.ENOENT:
+                raise
+
+    for client in clients_data:
+        client_name = client["name"]
+        
+        # Decide which value to use after restoring saved state.
+        # We have three different values: Old config file,
+        # new config file, and saved state.
+        # New config value takes precedence if it differs from old
+        # config value, otherwise use saved state.
+        for name, value in client_settings[client_name].items():
             try:
-                yield (name, special_settings[name]())
+                # For each value in new config, check if it differs
+                # from the old config value (Except for the "secret"
+                # attribute)
+                if name != "secret" and value != old_client_settings[client_name][name]:
+                    setattr(client, name, value)
             except KeyError:
-                yield (name, value)
+                pass
+
+        # Clients who has passed its expire date, can still be enabled if its
+        # last checker was sucessful. Clients who checkers failed before we
+        # stored it state is asumed to had failed checker during downtime.
+        if client["enabled"] and client["last_checked_ok"]:
+            if ((datetime.datetime.utcnow() - client["last_checked_ok"])
+                > client["interval"]):
+                if client["last_checker_status"] != 0:
+                    client["enabled"] = False
+                else:
+                    client["expires"] = datetime.datetime.utcnow() + client["timeout"]
+
+        client["changedstate"] = (multiprocessing_manager
+                                  .Condition(multiprocessing_manager
+                                             .Lock()))
+        if use_dbus:
+            new_client = ClientDBusTransitional.__new__(ClientDBusTransitional)
+            tcp_server.clients[client_name] = new_client
+            new_client.bus = bus
+            for name, value in client.iteritems():
+                setattr(new_client, name, value)
+            client_object_name = unicode(client_name).translate(
+                {ord("."): ord("_"),
+                 ord("-"): ord("_")})
+            new_client.dbus_object_path = (dbus.ObjectPath
+                                     ("/clients/" + client_object_name))
+            DBusObjectWithProperties.__init__(new_client,
+                                              new_client.bus,
+                                              new_client.dbus_object_path)
+        else:
+            tcp_server.clients[client_name] = Client.__new__(Client)
+            for name, value in client.iteritems():
+                setattr(tcp_server.clients[client_name], name, value)
+                
+        tcp_server.clients[client_name].decrypt_secret(
+            client_settings[client_name]["secret"])            
+        
+    # Create/remove clients based on new changes made to config
+    for clientname in set(old_client_settings) - set(client_settings):
+        del tcp_server.clients[clientname]
+    for clientname in set(client_settings) - set(old_client_settings):
+        tcp_server.clients[clientname] = (client_class(name = clientname,
+                                                       config =
+                                                       client_settings
+                                                       [clientname]))
     
-    tcp_server.clients.update(set(
-            client_class(name = section,
-                         config= dict(client_config_items(
-                        client_config, section)))
-            for section in client_config.sections()))
+
     if not tcp_server.clients:
         logger.warning("No clients defined")
         
@@ -2103,7 +2256,8 @@
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path
-                                  for c in tcp_server.clients)
+                                  for c in
+                                  tcp_server.clients.itervalues())
             
             @dbus.service.method(_interface,
                                  out_signature="a{oa{sv}}")
@@ -2111,15 +2265,15 @@
                 "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAll(""))
-                     for c in tcp_server.clients),
+                     for c in tcp_server.clients.itervalues()),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
-                for c in tcp_server.clients:
+                for c in tcp_server.clients.itervalues():
                     if c.dbus_object_path == object_path:
-                        tcp_server.clients.remove(c)
+                        del tcp_server.clients[c.name]
                         c.remove_from_connection()
                         # Don't signal anything except ClientRemoved
                         c.disable(quiet=True)
@@ -2139,11 +2293,44 @@
         service.cleanup()
         
         multiprocessing.active_children()
+        if not (tcp_server.clients or client_settings):
+            return
+
+        # Store client before exiting. Secrets are encrypted with key based
+        # on what config file has. If config file is removed/edited, old
+        # secret will thus be unrecovable.
+        clients = []
+        for client in tcp_server.clients.itervalues():
+            client.encrypt_secret(client_settings[client.name]["secret"])
+
+            client_dict = {}
+
+            # A list of attributes that will not be stored when shuting down.
+            exclude = set(("bus", "changedstate", "secret"))            
+            for name, typ in inspect.getmembers(dbus.service.Object):
+                exclude.add(name)
+                
+            client_dict["encrypted_secret"] = client.encrypted_secret
+            for attr in client.client_structure:
+                if attr not in exclude:
+                    client_dict[attr] = getattr(client, attr)
+
+            clients.append(client_dict) 
+            del client_settings[client.name]["secret"]
+            
+        try:
+            with os.fdopen(os.open(stored_state_path, os.O_CREAT|os.O_WRONLY|os.O_TRUNC, 0600), "wb") as stored_state:
+                pickle.dump((clients, client_settings), stored_state)
+        except IOError as e:
+            logger.warning("Could not save persistant state: {0}".format(e))
+            if e.errno != errno.ENOENT:
+                raise
+
+        # Delete all clients, and settings from config
         while tcp_server.clients:
-            client = tcp_server.clients.pop()
+            name, client = tcp_server.clients.popitem()
             if use_dbus:
                 client.remove_from_connection()
-            client.disable_hook = None
             # Don't signal anything except ClientRemoved
             client.disable(quiet=True)
             if use_dbus:
@@ -2151,14 +2338,18 @@
                 mandos_dbus_service.ClientRemoved(client
                                                   .dbus_object_path,
                                                   client.name)
+        client_settings.clear()
     
     atexit.register(cleanup)
     
-    for client in tcp_server.clients:
+    for client in tcp_server.clients.itervalues():
         if use_dbus:
             # Emit D-Bus signal
             mandos_dbus_service.ClientAdded(client.dbus_object_path)
-        client.enable()
+        # Need to initiate checking of clients
+        if client.enabled:
+            client.init_checker()
+
     
     tcp_server.enable()
     tcp_server.server_activate()

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2009-02-13 05:38:21 +0000
+++ mandos-options.xml	2011-11-09 17:16:03 +0000
@@ -85,5 +85,10 @@
     to the server if this option is turned off.  <emphasis>Only
     advanced users should consider changing this option</emphasis>.
   </para>
+
+  <para id="restore">
+    This option controls whether the server will restore any state from
+    last time it ran. Default is to try restore last state.
+  </para>
   
 </section>

=== modified file 'mandos.xml'
--- mandos.xml	2011-10-05 16:00:56 +0000
+++ mandos.xml	2011-11-09 17:16:03 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY TIMESTAMP "2011-10-22">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -94,6 +94,8 @@
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
+      <sbr/>
+      <arg><option>--no-restore</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -275,6 +277,13 @@
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
 	</listitem>
       </varlistentry>
+      
+      <varlistentry>
+	<term><option>--no-restore</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="restore"/>
+	</listitem>
+      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -509,9 +518,6 @@
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
-      The console log messages do not show a time stamp.
-    </para>
-    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-11-14 20:55:32 +0000
+++ plugins.d/mandos-client.c	2011-10-05 16:00:56 +0000
@@ -53,7 +53,7 @@
 				   sockaddr_in6, PF_INET6,
 				   SOCK_STREAM, uid_t, gid_t, open(),
 				   opendir(), DIR */
-#include <sys/stat.h>		/* open(), S_ISREG */
+#include <sys/stat.h>		/* open() */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   inet_pton(), connect() */
 #include <fcntl.h>		/* open() */
@@ -85,8 +85,6 @@
 				   raise() */
 #include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
 				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
-#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), WTERMSIG() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -110,8 +108,8 @@
 				   init_gnutls_session(),
 				   GNUTLS_* */
 #include <gnutls/openpgp.h>
-			 /* gnutls_certificate_set_openpgp_key_file(),
-			    GNUTLS_OPENPGP_FMT_BASE64 */
+			  /* gnutls_certificate_set_openpgp_key_file(),
+				   GNUTLS_OPENPGP_FMT_BASE64 */
 
 /* GPGME */
 #include <gpgme.h> 		/* All GPGME types, constants and
@@ -125,7 +123,6 @@
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
-#define HOOKDIR "/lib/mandos/network-hooks.d"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
@@ -133,7 +130,6 @@
 const char *argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
-const char *hookdir = HOOKDIR;
 
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
@@ -174,22 +170,13 @@
   perror(print_text);
 }
 
-int fprintf_plus(FILE *stream, const char *format, ...){
-  va_list ap;
-  va_start (ap, format);
-  
-  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
-			     program_invocation_short_name));
-  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
-}
-
 /*
  * Make additional room in "buffer" for at least BUFFER_SIZE more
  * bytes. "buffer_capacity" is how much is currently allocated,
  * "buffer_length" is how much is already used.
  */
 size_t incbuffer(char **buffer, size_t buffer_length,
-		 size_t buffer_capacity){
+		  size_t buffer_capacity){
   if(buffer_length + BUFFER_SIZE > buffer_capacity){
     *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
     if(buffer == NULL){
@@ -201,8 +188,9 @@
 }
 
 /* Add server to set of servers to retry periodically */
-int add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
-	       int af){
+int add_server(const char *ip, uint16_t port,
+		 AvahiIfIndex if_index,
+		 int af){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
@@ -210,9 +198,9 @@
     return -1;
   }
   *new_server = (server){ .ip = strdup(ip),
-			  .port = port,
-			  .if_index = if_index,
-			  .af = af };
+			 .port = port,
+			 .if_index = if_index,
+			 .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
     return -1;
@@ -240,8 +228,8 @@
 /* 
  * Initialize GPGME.
  */
-static bool init_gpgme(const char *seckey, const char *pubkey,
-		       const char *tempdir){
+static bool init_gpgme(const char *seckey,
+		       const char *pubkey, const char *tempdir){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
@@ -262,15 +250,15 @@
     
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf_plus(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
-		   gpgme_strsource(rc), gpgme_strerror(rc));
+      fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
+	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
     rc = gpgme_op_import(mc.ctx, pgp_data);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf_plus(stderr, "bad gpgme_op_import: %s: %s\n",
-		   gpgme_strsource(rc), gpgme_strerror(rc));
+      fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
+	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
@@ -283,23 +271,23 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Initializing GPGME\n");
+    fprintf(stderr, "Initializing GPGME\n");
   }
   
   /* Init GPGME */
   gpgme_check_version(NULL);
   rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_engine_check_version: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
   /* Set GPGME home directory for the OpenPGP engine only */
   rc = gpgme_get_engine_info(&engine_info);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_get_engine_info: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   while(engine_info != NULL){
@@ -311,17 +299,15 @@
     engine_info = engine_info->next;
   }
   if(engine_info == NULL){
-    fprintf_plus(stderr, "Could not set GPGME home dir to %s\n",
-		 tempdir);
+    fprintf(stderr, "Could not set GPGME home dir to %s\n", tempdir);
     return false;
   }
   
   /* Create new GPGME "context" */
   rc = gpgme_new(&(mc.ctx));
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "Mandos plugin mandos-client: "
-		 "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
-		 gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_new: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
@@ -346,24 +332,23 @@
   ssize_t plaintext_length = 0;
   
   if(debug){
-    fprintf_plus(stderr, "Trying to decrypt OpenPGP data\n");
+    fprintf(stderr, "Trying to decrypt OpenPGP data\n");
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
   rc = gpgme_data_new_from_mem(&dh_crypto, cryptotext, crypto_size,
 			       0);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
   
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "Mandos plugin mandos-client: "
-		 "bad gpgme_data_new: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
     return -1;
   }
@@ -372,32 +357,31 @@
      data buffer */
   rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_op_decrypt: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if(debug){
       gpgme_decrypt_result_t result;
       result = gpgme_op_decrypt_result(mc.ctx);
       if(result == NULL){
-	fprintf_plus(stderr, "gpgme_op_decrypt_result failed\n");
+	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
-	fprintf_plus(stderr, "Unsupported algorithm: %s\n",
-		     result->unsupported_algorithm);
-	fprintf_plus(stderr, "Wrong key usage: %u\n",
-		     result->wrong_key_usage);
+	fprintf(stderr, "Unsupported algorithm: %s\n",
+		result->unsupported_algorithm);
+	fprintf(stderr, "Wrong key usage: %u\n",
+		result->wrong_key_usage);
 	if(result->file_name != NULL){
-	  fprintf_plus(stderr, "File name: %s\n", result->file_name);
+	  fprintf(stderr, "File name: %s\n", result->file_name);
 	}
 	gpgme_recipient_t recipient;
 	recipient = result->recipients;
 	while(recipient != NULL){
-	  fprintf_plus(stderr, "Public key algorithm: %s\n",
-		       gpgme_pubkey_algo_name
-		       (recipient->pubkey_algo));
-	  fprintf_plus(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf_plus(stderr, "Secret key available: %s\n",
-		       recipient->status == GPG_ERR_NO_SECKEY
-		       ? "No" : "Yes");
+	  fprintf(stderr, "Public key algorithm: %s\n",
+		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
+	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
+	  fprintf(stderr, "Secret key available: %s\n",
+		  recipient->status == GPG_ERR_NO_SECKEY
+		  ? "No" : "Yes");
 	  recipient = recipient->next;
 	}
       }
@@ -406,7 +390,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Decryption of OpenPGP data succeeded\n");
+    fprintf(stderr, "Decryption of OpenPGP data succeeded\n");
   }
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
@@ -419,12 +403,12 @@
   *plaintext = NULL;
   while(true){
     plaintext_capacity = incbuffer(plaintext,
-				   (size_t)plaintext_length,
-				   plaintext_capacity);
+				      (size_t)plaintext_length,
+				      plaintext_capacity);
     if(plaintext_capacity == 0){
-      perror_plus("incbuffer");
-      plaintext_length = -1;
-      goto decrypt_end;
+	perror_plus("incbuffer");
+	plaintext_length = -1;
+	goto decrypt_end;
     }
     
     ret = gpgme_data_read(dh_plain, *plaintext + plaintext_length,
@@ -443,7 +427,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Decrypted password is: ");
+    fprintf(stderr, "Decrypted password is: ");
     for(ssize_t i = 0; i < plaintext_length; i++){
       fprintf(stderr, "%02hhX ", (*plaintext)[i]);
     }
@@ -471,7 +455,7 @@
 /* GnuTLS log function callback */
 static void debuggnutls(__attribute__((unused)) int level,
 			const char* string){
-  fprintf_plus(stderr, "GnuTLS: %s", string);
+  fprintf(stderr, "GnuTLS: %s", string);
 }
 
 static int init_gnutls_global(const char *pubkeyfilename,
@@ -479,13 +463,13 @@
   int ret;
   
   if(debug){
-    fprintf_plus(stderr, "Initializing GnuTLS\n");
+    fprintf(stderr, "Initializing GnuTLS\n");
   }
   
   ret = gnutls_global_init();
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "GnuTLS global_init: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "GnuTLS global_init: %s\n",
+	    safer_gnutls_strerror(ret));
     return -1;
   }
   
@@ -500,43 +484,41 @@
   /* OpenPGP credentials */
   ret = gnutls_certificate_allocate_credentials(&mc.cred);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "GnuTLS memory error: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "GnuTLS memory error: %s\n",
+	    safer_gnutls_strerror(ret));
     gnutls_global_deinit();
     return -1;
   }
   
   if(debug){
-    fprintf_plus(stderr, "Attempting to use OpenPGP public key %s and"
-		 " secret key %s as GnuTLS credentials\n",
-		 pubkeyfilename,
-		 seckeyfilename);
+    fprintf(stderr, "Attempting to use OpenPGP public key %s and"
+	    " secret key %s as GnuTLS credentials\n", pubkeyfilename,
+	    seckeyfilename);
   }
   
   ret = gnutls_certificate_set_openpgp_key_file
     (mc.cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr,
-		 "Error[%d] while reading the OpenPGP key pair ('%s',"
-		 " '%s')\n", ret, pubkeyfilename, seckeyfilename);
-    fprintf_plus(stderr, "The GnuTLS error is: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr,
+	    "Error[%d] while reading the OpenPGP key pair ('%s',"
+	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
+    fprintf(stderr, "The GnuTLS error is: %s\n",
+	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
   /* GnuTLS server initialization */
   ret = gnutls_dh_params_init(&mc.dh_params);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS DH parameter"
-		 " initialization: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS DH parameter initialization:"
+	    " %s\n", safer_gnutls_strerror(ret));
     goto globalfail;
   }
   ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS prime generation: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS prime generation: %s\n",
+	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
@@ -562,9 +544,8 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr,
-		 "Error in GnuTLS session initialization: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
+	    safer_gnutls_strerror(ret));
   }
   
   {
@@ -577,9 +558,9 @@
       }
     } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
     if(ret != GNUTLS_E_SUCCESS){
-      fprintf_plus(stderr, "Syntax error at: %s\n", err);
-      fprintf_plus(stderr, "GnuTLS error: %s\n",
-		   safer_gnutls_strerror(ret));
+      fprintf(stderr, "Syntax error at: %s\n", err);
+      fprintf(stderr, "GnuTLS error: %s\n",
+	      safer_gnutls_strerror(ret));
       gnutls_deinit(*session);
       return -1;
     }
@@ -594,8 +575,8 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error setting GnuTLS credentials: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
+	    safer_gnutls_strerror(ret));
     gnutls_deinit(*session);
     return -1;
   }
@@ -646,7 +627,7 @@
     pf = PF_INET;
     break;
   default:
-    fprintf_plus(stderr, "Bad address family: %d\n", af);
+    fprintf(stderr, "Bad address family: %d\n", af);
     errno = EINVAL;
     return -1;
   }
@@ -657,8 +638,8 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Setting up a TCP connection to %s, port %"
-		 PRIu16 "\n", ip, port);
+    fprintf(stderr, "Setting up a TCP connection to %s, port %" PRIu16
+	    "\n", ip, port);
   }
   
   tcp_sd = socket(pf, SOCK_STREAM, 0);
@@ -690,7 +671,7 @@
   }
   if(ret == 0){
     int e = errno;
-    fprintf_plus(stderr, "Bad address: %s\n", ip);
+    fprintf(stderr, "Bad address: %s\n", ip);
     errno = e;
     goto mandos_end;
   }
@@ -701,10 +682,10 @@
     
     if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
        (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
-				-Wunreachable-code*/
+			      -Wunreachable-code*/
       if(if_index == AVAHI_IF_UNSPEC){
-	fprintf_plus(stderr, "An IPv6 link-local address is"
-		     " incomplete without a network interface\n");
+	fprintf(stderr, "An IPv6 link-local address is incomplete"
+		" without a network interface\n");
 	errno = EINVAL;
 	goto mandos_end;
       }
@@ -728,12 +709,12 @@
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
 	perror_plus("if_indextoname");
       } else {
-	fprintf_plus(stderr, "Connection to: %s%%%s, port %" PRIu16
-		     "\n", ip, interface, port);
+	fprintf(stderr, "Connection to: %s%%%s, port %" PRIu16 "\n",
+		ip, interface, port);
       }
     } else {
-      fprintf_plus(stderr, "Connection to: %s, port %" PRIu16 "\n",
-		   ip, port);
+      fprintf(stderr, "Connection to: %s, port %" PRIu16 "\n", ip,
+	      port);
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
@@ -749,7 +730,7 @@
       perror_plus("inet_ntop");
     } else {
       if(strcmp(addrstr, ip) != 0){
-	fprintf_plus(stderr, "Canonical address form: %s\n", addrstr);
+	fprintf(stderr, "Canonical address form: %s\n", addrstr);
       }
     }
   }
@@ -783,7 +764,7 @@
   while(true){
     size_t out_size = strlen(out);
     ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
-					out_size - written));
+				   out_size - written));
     if(ret == -1){
       int e = errno;
       perror_plus("write");
@@ -809,7 +790,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Establishing TLS session with %s\n", ip);
+    fprintf(stderr, "Establishing TLS session with %s\n", ip);
   }
   
   if(quit_now){
@@ -835,7 +816,7 @@
   
   if(ret != GNUTLS_E_SUCCESS){
     if(debug){
-      fprintf_plus(stderr, "*** GnuTLS Handshake failed ***\n");
+      fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
     errno = EPROTO;
@@ -845,8 +826,8 @@
   /* Read OpenPGP packet that contains the wanted password */
   
   if(debug){
-    fprintf_plus(stderr, "Retrieving OpenPGP encrypted password from"
-		 " %s\n", ip);
+    fprintf(stderr, "Retrieving OpenPGP encrypted password from %s\n",
+	    ip);
   }
   
   while(true){
@@ -857,7 +838,7 @@
     }
     
     buffer_capacity = incbuffer(&buffer, buffer_length,
-				buffer_capacity);
+				   buffer_capacity);
     if(buffer_capacity == 0){
       int e = errno;
       perror_plus("incbuffer");
@@ -890,16 +871,15 @@
 	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
-	  fprintf_plus(stderr, "*** GnuTLS Re-handshake failed "
-		       "***\n");
+	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
 	  errno = EPROTO;
 	  goto mandos_end;
 	}
 	break;
       default:
-	fprintf_plus(stderr, "Unknown error while reading data from"
-		     " encrypted session with Mandos server\n");
+	fprintf(stderr, "Unknown error while reading data from"
+		" encrypted session with Mandos server\n");
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	errno = EIO;
 	goto mandos_end;
@@ -910,7 +890,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Closing TLS session\n");
+    fprintf(stderr, "Closing TLS session\n");
   }
   
   if(quit_now){
@@ -928,7 +908,8 @@
   
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
-    decrypted_buffer_size = pgp_packet_decrypt(buffer, buffer_length,
+    decrypted_buffer_size = pgp_packet_decrypt(buffer,
+					       buffer_length,
 					       &decrypted_buffer);
     if(decrypted_buffer_size >= 0){
       
@@ -945,8 +926,8 @@
 	if(ret == 0 and ferror(stdout)){
 	  int e = errno;
 	  if(debug){
-	    fprintf_plus(stderr, "Error writing encrypted data: %s\n",
-			 strerror(errno));
+	    fprintf(stderr, "Error writing encrypted data: %s\n",
+		    strerror(errno));
 	  }
 	  errno = e;
 	  goto mandos_end;
@@ -1009,10 +990,9 @@
   switch(event){
   default:
   case AVAHI_RESOLVER_FAILURE:
-    fprintf_plus(stderr, "(Avahi Resolver) Failed to resolve service "
-		 "'%s' of type '%s' in domain '%s': %s\n", name, type,
-		 domain,
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "(Avahi Resolver) Failed to resolve service '%s'"
+	    " of type '%s' in domain '%s': %s\n", name, type, domain,
+	    avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_RESOLVER_FOUND:
@@ -1020,9 +1000,9 @@
       char ip[AVAHI_ADDRESS_STR_MAX];
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
-	fprintf_plus(stderr, "Mandos server \"%s\" found on %s (%s, %"
-		     PRIdMAX ") on port %" PRIu16 "\n", name,
-		     host_name, ip, (intmax_t)interface, port);
+	fprintf(stderr, "Mandos server \"%s\" found on %s (%s, %"
+		PRIdMAX ") on port %" PRIu16 "\n", name, host_name,
+		ip, (intmax_t)interface, port);
       }
       int ret = start_mandos_communication(ip, port, interface,
 					   avahi_proto_to_af(proto));
@@ -1060,8 +1040,8 @@
   default:
   case AVAHI_BROWSER_FAILURE:
     
-    fprintf_plus(stderr, "(Avahi browser) %s\n",
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "(Avahi browser) %s\n",
+	    avahi_strerror(avahi_server_errno(mc.server)));
     avahi_simple_poll_quit(mc.simple_poll);
     return;
     
@@ -1074,9 +1054,8 @@
     if(avahi_s_service_resolver_new(mc.server, interface, protocol,
 				    name, type, domain, protocol, 0,
 				    resolve_callback, NULL) == NULL)
-      fprintf_plus(stderr, "Avahi: Failed to resolve service '%s':"
-		   " %s\n", name,
-		   avahi_strerror(avahi_server_errno(mc.server)));
+      fprintf(stderr, "Avahi: Failed to resolve service '%s': %s\n",
+	      name, avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_BROWSER_REMOVE:
@@ -1085,8 +1064,7 @@
   case AVAHI_BROWSER_ALL_FOR_NOW:
   case AVAHI_BROWSER_CACHE_EXHAUSTED:
     if(debug){
-      fprintf_plus(stderr, "No Mandos server found, still"
-		   " searching...\n");
+      fprintf(stderr, "No Mandos server found, still searching...\n");
     }
     break;
   }
@@ -1107,131 +1085,107 @@
   errno = old_errno;
 }
 
-bool get_flags(const char *ifname, struct ifreq *ifr){
-  int ret;
-  
-  int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-  if(s < 0){
-    perror_plus("socket");
-    return false;
-  }
-  strcpy(ifr->ifr_name, ifname);
-  ret = ioctl(s, SIOCGIFFLAGS, ifr);
-  if(ret == -1){
+/* 
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int good_interface(const struct dirent *if_entry){
+  ssize_t ssret;
+  char *flagname = NULL;
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
+		     if_entry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
+  if(flags_fd == -1){
+    perror_plus("open");
+    free(flagname);
+    return 0;
+  }
+  free(flagname);
+  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
+  /* read line from flags_fd */
+  ssize_t to_read = 2+(sizeof(ifreq_flags)*2)+1; /* "0x1003\n" */
+  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
+  flagstring[(size_t)to_read] = '\0';
+  if(flagstring == NULL){
+    perror_plus("malloc");
+    close(flags_fd);
+    return 0;
+  }
+  while(to_read > 0){
+    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
+					     (size_t)to_read));
+    if(ssret == -1){
+      perror_plus("read");
+      free(flagstring);
+      close(flags_fd);
+      return 0;
+    }
+    to_read -= ssret;
+    if(ssret == 0){
+      break;
+    }
+  }
+  close(flags_fd);
+  intmax_t tmpmax;
+  char *tmp;
+  errno = 0;
+  tmpmax = strtoimax(flagstring, &tmp, 0);
+  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
+					 and not (isspace(*tmp)))
+     or tmpmax != (ifreq_flags)tmpmax){
     if(debug){
-      perror_plus("ioctl SIOCGIFFLAGS");
+      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
+	      flagstring, if_entry->d_name);
     }
-    return false;
+    free(flagstring);
+    return 0;
   }
-  return true;
-}
-
-bool good_flags(const char *ifname, const struct ifreq *ifr){
-  
+  free(flagstring);
+  ifreq_flags flags = (ifreq_flags)tmpmax;
   /* Reject the loopback device */
-  if(ifr->ifr_flags & IFF_LOOPBACK){
+  if(flags & IFF_LOOPBACK){
     if(debug){
-      fprintf_plus(stderr, "Rejecting loopback interface \"%s\"\n",
-		   ifname);
+      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
   /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (ifr->ifr_flags & IFF_POINTOPOINT)){
+  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
     if(debug){
-      fprintf_plus(stderr, "Accepting point-to-point interface"
-		   " \"%s\"\n", ifname);
+      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return true;
+    return 1;
   }
   /* Otherwise, reject non-broadcast-capable devices */
-  if(not (ifr->ifr_flags & IFF_BROADCAST)){
+  if(not (flags & IFF_BROADCAST)){
     if(debug){
-      fprintf_plus(stderr, "Rejecting non-broadcast interface"
-		   " \"%s\"\n", ifname);
+      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
   /* Reject non-ARP interfaces (including dummy interfaces) */
-  if(ifr->ifr_flags & IFF_NOARP){
+  if(flags & IFF_NOARP){
     if(debug){
-      fprintf_plus(stderr, "Rejecting non-ARP interface \"%s\"\n",
-		   ifname);
+      fprintf(stderr, "Rejecting non-ARP interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
-  
   /* Accept this device */
   if(debug){
-    fprintf_plus(stderr, "Interface \"%s\" is good\n", ifname);
-  }
-  return true;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  
-  struct ifreq ifr;
-  if(not get_flags(if_entry->d_name, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
-  }
-  return 1;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device which is up.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int up_interface(const struct dirent *if_entry){
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  
-  struct ifreq ifr;
-  if(not get_flags(if_entry->d_name, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  /* Reject down interfaces */
-  if(not (ifr.ifr_flags & IFF_UP)){
-    if(debug){
-      fprintf_plus(stderr, "Rejecting down interface \"%s\"\n",
-		   if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  /* Reject non-running interfaces */
-  if(not (ifr.ifr_flags & IFF_RUNNING)){
-    if(debug){
-      fprintf_plus(stderr, "Rejecting non-running interface \"%s\"\n",
-		   if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
+    fprintf(stderr, "Interface \"%s\" is acceptable\n",
+	    if_entry->d_name);
   }
   return 1;
 }
@@ -1247,63 +1201,6 @@
   return 1;
 }
 
-/* Is this directory entry a runnable program? */
-int runnable_hook(const struct dirent *direntry){
-  int ret;
-  size_t sret;
-  struct stat st;
-  
-  if((direntry->d_name)[0] == '\0'){
-    /* Empty name? */
-    return 0;
-  }
-  
-  sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
-		"abcdefghijklmnopqrstuvwxyz"
-		"0123456789"
-		"_-");
-  if((direntry->d_name)[sret] != '\0'){
-    /* Contains non-allowed characters */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" with bad name\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  
-  char *fullname = NULL;
-  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
-  if(ret < 0){
-    perror_plus("asprintf");
-    return 0;
-  }
-  
-  ret = stat(fullname, &st);
-  if(ret == -1){
-    if(debug){
-      perror_plus("Could not stat hook");
-    }
-    return 0;
-  }
-  if(not (S_ISREG(st.st_mode))){
-    /* Not a regular file */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" - not a file\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  if(not (st.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))){
-    /* Not executable */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" - not executable\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  return 1;
-}
-
 int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
   int ret;
   struct timespec now;
@@ -1313,14 +1210,14 @@
   while(true){
     if(mc.current_server == NULL){
       if (debug){
-	fprintf_plus(stderr, "Wait until first server is found."
-		     " No timeout!\n");
+	fprintf(stderr,
+		"Wait until first server is found. No timeout!\n");
       }
       ret = avahi_simple_poll_iterate(s, -1);
     } else {
       if (debug){
-	fprintf_plus(stderr, "Check current_server if we should run"
-		     " it, or wait\n");
+	fprintf(stderr, "Check current_server if we should run it,"
+		" or wait\n");
       }
       /* the current time */
       ret = clock_gettime(CLOCK_MONOTONIC, &now);
@@ -1342,8 +1239,7 @@
 		    - ((intmax_t)waited_time.tv_nsec / 1000000));
       
       if (debug){
-	fprintf_plus(stderr, "Blocking for %" PRIdMAX " ms\n",
-		     block_time);
+	fprintf(stderr, "Blocking for %" PRIdMAX " ms\n", block_time);
       }
       
       if(block_time <= 0){
@@ -1369,111 +1265,13 @@
       ret = avahi_simple_poll_iterate(s, (int)block_time);
     }
     if(ret != 0){
-      if (ret > 0 or errno != EINTR){
+      if (ret > 0 or errno != EINTR) {
 	return (ret != 1) ? ret : 0;
       }
     }
   }
 }
 
-bool run_network_hooks(const char *mode, const char *interface,
-		       const float delay){
-  struct dirent **direntries;
-  struct dirent *direntry;
-  int ret;
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-  if(numhooks == -1){
-    perror_plus("scandir");
-  } else {
-    int devnull = open("/dev/null", O_RDONLY);
-    for(int i = 0; i < numhooks; i++){
-      direntry = direntries[0];
-      char *fullname = NULL;
-      ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
-      if(ret < 0){
-	perror_plus("asprintf");
-	continue;
-      }
-      pid_t hook_pid = fork();
-      if(hook_pid == 0){
-	/* Child */
-	dup2(devnull, STDIN_FILENO);
-	close(devnull);
-	dup2(STDERR_FILENO, STDOUT_FILENO);
-	ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  return false;
-	}
-	ret = setenv("DEVICE", interface, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  return false;
-	}
-	ret = setenv("VERBOSE", debug ? "1" : "0", 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  return false;
-	}
-	ret = setenv("MODE", mode, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  return false;
-	}
-	char *delaystring;
-	ret = asprintf(&delaystring, "%f", delay);
-	if(ret == -1){
-	  perror_plus("asprintf");
-	  return false;
-	}
-	ret = setenv("DELAY", delaystring, 1);
-	if(ret == -1){
-	  free(delaystring);
-	  perror_plus("setenv");
-	  return false;
-	}
-	free(delaystring);
-	ret = execl(fullname, direntry->d_name, mode, NULL);
-	perror_plus("execl");
-      } else {
-	int status;
-	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
-	  perror_plus("waitpid");
-	  free(fullname);
-	  continue;
-	}
-	if(WIFEXITED(status)){
-	  if(WEXITSTATUS(status) != 0){
-	    fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
-			 " with status %d\n", direntry->d_name,
-			 WEXITSTATUS(status));
-	    free(fullname);
-	    continue;
-	  }
-	} else if(WIFSIGNALED(status)){
-	  fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
-		       " signal %d\n", direntry->d_name,
-		       WTERMSIG(status));
-	  free(fullname);
-	  continue;
-	} else {
-	  fprintf_plus(stderr, "Warning: network hook \"%s\""
-		       " crashed\n", direntry->d_name);
-	  free(fullname);
-	  continue;
-	}
-      }
-      free(fullname);
-      if(quit_now){
-	break;
-      }
-    }
-    close(devnull);
-  }
-  return true;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1561,10 +1359,6 @@
 	.arg = "SECONDS",
 	.doc = "Retry interval used when denied by the mandos server",
 	.group = 2 },
-      { .name = "network-hook-dir", .key = 133,
-	.arg = "DIR",
-	.doc = "Directory where network hooks are located",
-	.group = 2 },
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -1623,9 +1417,6 @@
 	  argp_error(state, "Bad retry interval");
 	}
 	break;
-      case 133:			/* --network-hook-dir */
-	hookdir = arg;
-	break;
 	/*
 	 * These reproduce what we would get without ARGP_NO_HELP
 	 */
@@ -1637,9 +1428,7 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
-	fprintf_plus(state->out_stream,
-		     "Mandos plugin mandos-client: ");
-	fprintf_plus(state->out_stream, "%s\n", argp_program_version);
+	fprintf(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;
       default:
@@ -1690,8 +1479,7 @@
 	if(ret == -1){
 	  perror_plus("fstat");
 	} else {
-	  if(S_ISREG(st.st_mode)
-	     and st.st_uid == 0 and st.st_gid == 0){
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
 	    ret = fchown(seckey_fd, uid, gid);
 	    if(ret == -1){
 	      perror_plus("fchown");
@@ -1711,8 +1499,7 @@
 	if(ret == -1){
 	  perror_plus("fstat");
 	} else {
-	  if(S_ISREG(st.st_mode)
-	     and st.st_uid == 0 and st.st_gid == 0){
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
 	    ret = fchown(pubkey_fd, uid, gid);
 	    if(ret == -1){
 	      perror_plus("fchown");
@@ -1731,45 +1518,19 @@
     }
   }
   
-  /* Run network hooks */
-  {
-    /* Re-raise priviliges */
-    errno = 0;
-    ret = seteuid(0);
-    if(ret == -1){
-      perror_plus("seteuid");
-    }
-    if(not run_network_hooks("start", interface, delay)){
-      goto end;
-    }
-    /* Lower privileges */
-    errno = 0;
-    ret = seteuid(uid);
-    if(ret == -1){
-      perror_plus("seteuid");
-    }
-  }
-  
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-  
+
   if(interface[0] == '\0'){
     struct dirent **direntries;
-    /* First look for interfaces that are up */
-    ret = scandir(sys_class_net, &direntries, up_interface,
+    ret = scandir(sys_class_net, &direntries, good_interface,
 		  alphasort);
-    if(ret == 0){
-      /* No up interfaces, look for any good interfaces */
-      free(direntries);
-      ret = scandir(sys_class_net, &direntries, good_interface,
-		    alphasort);
-    }
     if(ret >= 1){
-      /* Pick the first interface returned */
+      /* Pick the first good interface */
       interface = strdup(direntries[0]->d_name);
       if(debug){
-	fprintf_plus(stderr, "Using interface \"%s\"\n", interface);
+	fprintf(stderr, "Using interface \"%s\"\n", interface);
       }
       if(interface == NULL){
 	perror_plus("malloc");
@@ -1780,7 +1541,7 @@
       free(direntries);
     } else {
       free(direntries);
-      fprintf_plus(stderr, "Could not find a network interface\n");
+      fprintf(stderr, "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
     }
@@ -1792,8 +1553,7 @@
   srand((unsigned int) time(NULL));
   mc.simple_poll = avahi_simple_poll_new();
   if(mc.simple_poll == NULL){
-    fprintf_plus(stderr,
-		 "Avahi: Failed to create simple poll object.\n");
+    fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -1865,7 +1625,7 @@
   if(strcmp(interface, "none") != 0){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
-      fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
+      fprintf(stderr, "No such interface: \"%s\"\n", interface);
       exitcode = EX_UNAVAILABLE;
       goto end;
     }
@@ -1991,10 +1751,18 @@
 #endif	/* __linux__ */
     /* Lower privileges */
     errno = 0;
-    /* Lower privileges */
-    ret = seteuid(uid);
-    if(ret == -1){
-      perror_plus("seteuid");
+    if(take_down_interface){
+      /* Lower privileges */
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+    } else {
+      /* Lower privileges permanently */
+      ret = setuid(uid);
+      if(ret == -1){
+	perror_plus("setuid");
+      }
     }
   }
   
@@ -2004,7 +1772,7 @@
   
   ret = init_gnutls_global(pubkey, seckey);
   if(ret == -1){
-    fprintf_plus(stderr, "init_gnutls_global failed\n");
+    fprintf(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -2026,7 +1794,7 @@
   }
   
   if(not init_gpgme(pubkey, seckey, tempdir)){
-    fprintf_plus(stderr, "init_gpgme failed\n");
+    fprintf(stderr, "init_gpgme failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -2042,7 +1810,7 @@
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
     if(address == NULL){
-      fprintf_plus(stderr, "No colon in address\n");
+      fprintf(stderr, "No colon in address\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -2056,7 +1824,7 @@
     tmpmax = strtoimax(address+1, &tmp, 10);
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
        or tmpmax != (uint16_t)tmpmax){
-      fprintf_plus(stderr, "Bad port number\n");
+      fprintf(stderr, "Bad port number\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -2092,8 +1860,8 @@
 	break;
       }
       if(debug){
-	fprintf_plus(stderr, "Retrying in %d seconds\n",
-		     (int)retry_interval);
+	fprintf(stderr, "Retrying in %d seconds\n",
+		(int)retry_interval);
       }
       sleep((int)retry_interval);
     }
@@ -2101,7 +1869,7 @@
     if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
-    
+
     goto end;
   }
   
@@ -2129,8 +1897,8 @@
   
   /* Check if creating the Avahi server object succeeded */
   if(mc.server == NULL){
-    fprintf_plus(stderr, "Failed to create Avahi server: %s\n",
-		 avahi_strerror(error));
+    fprintf(stderr, "Failed to create Avahi server: %s\n",
+	    avahi_strerror(error));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -2144,8 +1912,8 @@
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
 				   NULL, 0, browse_callback, NULL);
   if(sb == NULL){
-    fprintf_plus(stderr, "Failed to create service browser: %s\n",
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "Failed to create service browser: %s\n",
+	    avahi_strerror(avahi_server_errno(mc.server)));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -2157,20 +1925,20 @@
   /* Run the main loop */
   
   if(debug){
-    fprintf_plus(stderr, "Starting Avahi loop search\n");
+    fprintf(stderr, "Starting Avahi loop search\n");
   }
 
   ret = avahi_loop_with_timeout(mc.simple_poll,
 				(int)(retry_interval * 1000));
   if(debug){
-    fprintf_plus(stderr, "avahi_loop_with_timeout exited %s\n",
-		 (ret == 0) ? "successfully" : "with error");
+    fprintf(stderr, "avahi_loop_with_timeout exited %s\n",
+	    (ret == 0) ? "successfully" : "with error");
   }
   
  end:
   
   if(debug){
-    fprintf_plus(stderr, "%s exiting\n", argv[0]);
+    fprintf(stderr, "%s exiting\n", argv[0]);
   }
   
   /* Cleanup things */
@@ -2204,24 +1972,19 @@
     }
   }
   
-  /* Re-raise priviliges */
-  {
+  /* Take down the network interface */
+  if(take_down_interface){
+    /* Re-raise priviliges */
     errno = 0;
     ret = seteuid(0);
     if(ret == -1){
       perror_plus("seteuid");
     }
-    /* Run network hooks */
-    if(not run_network_hooks("stop", interface, delay)){
-      goto end;
-    }
-    
-    /* Take down the network interface */
-    if(take_down_interface and geteuid() == 0){
+    if(geteuid() == 0){
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
 	perror_plus("ioctl SIOCGIFFLAGS");
-      } else if(network.ifr_flags & IFF_UP){
+      } else if(network.ifr_flags & IFF_UP) {
 	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
@@ -2232,14 +1995,14 @@
       if(ret == -1){
 	perror_plus("close");
       }
+      /* Lower privileges permanently */
+      errno = 0;
+      ret = setuid(uid);
+      if(ret == -1){
+	perror_plus("setuid");
+      }
     }
   }
-  /* Lower privileges permanently */
-  errno = 0;
-  ret = setuid(uid);
-  if(ret == -1){
-    perror_plus("setuid");
-  }
   
   /* Removes the GPGME temp directory and all files inside */
   if(tempdir_created){
@@ -2259,8 +2022,8 @@
 	}
 	ret = remove(fullname);
 	if(ret == -1){
-	  fprintf_plus(stderr, "remove(\"%s\"): %s\n", fullname,
-		       strerror(errno));
+	  fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
+		  strerror(errno));
 	}
 	free(fullname);
       }

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-11-13 20:49:21 +0000
+++ plugins.d/mandos-client.xml	2011-10-05 16:00:56 +0000
@@ -102,10 +102,6 @@
       </arg>
       <sbr/>
       <arg>
-	<option>--network-hook-dir<replaceable>DIR</replaceable></option>
-      </arg>
-      <sbr/>
-      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -315,18 +311,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-
-      <varlistentry>
-	<term><option>--network-hook-dir=<replaceable
-	>DIR</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Network hook directory.  The default directory is
-	    <quote><filename class="directory"
-	    >/lib/mandos/network-hooks.d</filename></quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>

